//+------------------------------------------------------------------+
//|                                           ADX_DI+&&DI- Cross.mq4 |
//|                                                           Necron |
//|                                     mailto:   necronfx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Necron, 2010"
#property link      "mailto:   necronfx@gmail.com"

extern double Lots = 0.1;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double plus,minus,plus_pr,minus_pr,high,low;
   int cnt, ticket, total;


   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
// to simplify the coding and speed up access
// data are put into internal variables
      plus=iADX(NULL,0,3,PRICE_CLOSE,MODE_PLUSDI,0);
      plus_pr=iADX(NULL,0,3,PRICE_CLOSE,MODE_PLUSDI,1);
      minus=iADX(NULL,0,3,PRICE_CLOSE,MODE_MINUSDI,0);
      minus_pr=iADX(NULL,0,3,PRICE_CLOSE,MODE_MINUSDI,1);
      high=iHigh(NULL,0,1);
      low=iLow(NULL,0,1);
      
      
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(plus_pr<minus_pr && plus>minus && Bid>high)
        {
        ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"ADX",16384,0,Lime);

         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(minus_pr<plus_pr && minus>plus && Bid<low )
        {
            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"ADX",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(minus_pr<plus_pr && minus>plus && Bid<low)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
           }
         else // go to short position
           {
            // should it be closed?
            if(plus_pr<minus_pr && plus>minus && Bid>high)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            }
        }
     }
   return(0);
  }
// the end.